package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.BmstruckDetailsOrder;
import com.steerinfo.framework.mapper.IBaseMapper;
import java.math.*;
import java.util.List;
import java.util.Map;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

@Mapper
public interface BmstruckDetailsOrderMapper extends IBaseMapper<BmstruckDetailsOrder, BigDecimal> {

    /**
     * 展示汽运详单
     * @param mapVal
     * @return
     */
    List<Map<String,Object>> getTruckDetailsOrderList(Map<String,Object> mapVal);

    /**
     * 新增汽运详单
     * @param bmstruckDetailsOrder
     * @return
     */
    int insertSelective(BmstruckDetailsOrder bmstruckDetailsOrder);

    /**
     * 查询最大id
     * @return
     */
    BigDecimal selectMaxId();

    /**
     * 运单id
     * @param orderId
     * @return
     */
    BigDecimal getOrderType(BigDecimal orderId);

    /**
     * 展示汽运实绩列表
     * @param mapVal
     * @return
     */
    List<Map<String, Object>> getTruckResultList(Map<String, Object> mapVal);

    /**
     * 查询计算因子
     * @param orderId
     * @return
     */
    BigDecimal getFormulaMembers(BigDecimal orderId);

    /**
     * 得到价格id
     * @return
     */
    List<Map<String, Object>> getPriceId();

    /**
     * 得到价格
     * @return
     */
    BigDecimal getPriceValue(BigDecimal priceId);

    /**
     * 得到到厂湿重
     * @param orderId
     * @return
     */
    BigDecimal getNetWeight(BigDecimal orderId);

//    /**
//     * 生成汽运账单
//     * @param mapList
//     * @return
//     */
//    int addTruckStatement(List<Map<String, Object>> mapList);

    @Select("select seq_BMSTRUCK_STATEMENT.nextval from dual")
    BigDecimal selectDetailsId();

    /**
     * 展示汽运实绩列表
     * @param mapVal
     * @return
     */
    List<Map<String, Object>> getSaleTruckResultList(Map<String,Object> mapVal);

    /**
     * 查看未转账单的详单
     * @param mapVal
     * @return
     */
    List<Map<String, Object>> getUnFinishedTruckDetailsOrderList(Map<String, Object> mapVal);

    /**
     * 查看详单
     * @param mapVal
     * @return
     */
    List<Map<String, Object>> getSaleTruckDetailsOrderList(Map<String, Object> mapVal);
}